package de.hft.stuttgart.citydoctor2.gui.tree;

import de.hft.stuttgart.citydoctor2.datastructure.TunnelConstructiveElement;
import de.hft.stuttgart.citydoctor2.gui.CheckStatus;
import de.hft.stuttgart.citydoctor2.gui.Renderer;

public class TunnelConstructiveElementNode extends Renderable{

    private final TunnelConstructiveElement tce;

    public TunnelConstructiveElementNode(TunnelConstructiveElement tce) {
        this.tce = tce;
    }

    @Override
    public String getText() {
        return tce.getGmlId().getGmlString();
    }

    @Override
    public void visit(Renderer renderer) {
        renderer.render(tce);
    }

    @Override
    public void refreshTextColor() {
        if (!tce.isValidated()) {
            setStatus(CheckStatus.NOT_CHECKED);
        } else if (tce.containsAnyError()) {
            setStatus(CheckStatus.ERROR);
        } else {
            setStatus(CheckStatus.OK);
        }
    }
}
