package de.hft.stuttgart.citydoctor2.webservice.database;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import de.hft.stuttgart.citydoctor2.webservice.model.ParseStatus;
import de.hft.stuttgart.citydoctor2.webservice.model.entities.GmlFile;
import de.hft.stuttgart.citydoctor2.webservice.model.entities.WebCityDoctorModel;
import de.hft.stuttgart.citydoctor2.webservice.utils.HibernateUtils;

public class ModelQueries {

	private ModelQueries() {
		// only static usage
	}

	public static void storeModel(WebCityDoctorModel webModel, EntityManager manager) {
		try {
			manager.getTransaction().begin();
			manager.persist(webModel);
		} finally {
			manager.getTransaction().commit();
		}
	}

	public static void updateStatus(WebCityDoctorModel webModel, ParseStatus status, EntityManager manager) {
		try {
			manager.getTransaction().begin();
			webModel.setStatus(status);
		} finally {
			manager.getTransaction().commit();
		}
	}

	public static void updateModelWithBlob(WebCityDoctorModel webModel, GmlFile blob, EntityManager manager) {
		try {
			manager.getTransaction().begin();
			manager.persist(blob);
			webModel.setZipFile(blob);
		} finally {
			manager.getTransaction().commit();
		}
	}

	public static void cleanup() {
		EntityManager manager = HibernateUtils.createManager();
		try {
			manager.getTransaction().begin();
			Query query = manager.createQuery("DELETE FROM WebCityDoctorModel WHERE status = " + ParseStatus.PARSING.ordinal());
			query.executeUpdate();
			manager.getTransaction().commit();
		} finally {
			manager.close();
		}
	}
}
